//
//  GGG4W.cs
//  Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
//
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Collections.Specialized;
using System.Text;
using System.Diagnostics;
using System.Resources;
using System.Reflection;
using System.Threading;

namespace GGG4W
{
	/// <summary>
	/// GGG4WCEBhE
	/// </summary>
	public class GGG4W : System.Windows.Forms.Form {
		private System.Windows.Forms.ColumnHeader path;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuSearch;
		private System.Windows.Forms.MenuItem menuStop;
		private System.Windows.Forms.Button btnSearch;
		private System.Windows.Forms.ListView lvResult;
		private System.Windows.Forms.TextBox msgCurrentFilePath;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuCommand;
		private System.Windows.Forms.ColumnHeader matchRate;
		private System.Windows.Forms.MenuItem menuOpenGraphicFile;
		private System.Windows.Forms.MenuItem menuCreateIndexFile;
		private System.Windows.Forms.MenuItem menuHelp;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuVersion;
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

		public GGG4W() {
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			//
			// TODO: InitializeComponent ĂяǒɁARXgN^ R[hǉĂB
			//

			m_rmStrings = new ResourceManager("GGG4W.Resource1", GetType().Assembly);

			m_setting = new TSetting();
			if (m_setting.Beginning())
				m_settingSaved = m_setting.Clone();

			m_gs = new TGraphicSearch();
			m_gs.LoadSetting(ref m_setting);
			m_gs.HitItemCallback = new TGraphicSearch.HitItemCallbackHandler(OnHitItem);
			m_gs.ProgressCallback = new TGraphicSearch.ProgressCallbackHandler(OnProgress);
			m_gs.SearchEndCallback = new TGraphicSearch.SearchEndCallbackHandler(OnSearchEnd);
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(GGG4W));
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuOpenGraphicFile = new System.Windows.Forms.MenuItem();
			this.menuCreateIndexFile = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.menuCommand = new System.Windows.Forms.MenuItem();
			this.menuSearch = new System.Windows.Forms.MenuItem();
			this.menuStop = new System.Windows.Forms.MenuItem();
			this.menuHelp = new System.Windows.Forms.MenuItem();
			this.menuVersion = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.btnSearch = new System.Windows.Forms.Button();
			this.lvResult = new System.Windows.Forms.ListView();
			this.matchRate = new System.Windows.Forms.ColumnHeader();
			this.path = new System.Windows.Forms.ColumnHeader();
			this.msgCurrentFilePath = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFile,
																					 this.menuCommand,
																					 this.menuHelp,
																					 this.menuItem3});
			this.mainMenu.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("mainMenu.RightToLeft")));
			// 
			// menuFile
			// 
			this.menuFile.Enabled = ((bool)(resources.GetObject("menuFile.Enabled")));
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuCreateIndexFile,
																					 this.menuOpenGraphicFile,
																					 this.menuItem2,
																					 this.menuExit});
			this.menuFile.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuFile.Shortcut")));
			this.menuFile.ShowShortcut = ((bool)(resources.GetObject("menuFile.ShowShortcut")));
			this.menuFile.Text = resources.GetString("menuFile.Text");
			this.menuFile.Visible = ((bool)(resources.GetObject("menuFile.Visible")));
			// 
			// menuOpenGraphicFile
			// 
			this.menuOpenGraphicFile.Enabled = ((bool)(resources.GetObject("menuOpenGraphicFile.Enabled")));
			this.menuOpenGraphicFile.Index = 1;
			this.menuOpenGraphicFile.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuOpenGraphicFile.Shortcut")));
			this.menuOpenGraphicFile.ShowShortcut = ((bool)(resources.GetObject("menuOpenGraphicFile.ShowShortcut")));
			this.menuOpenGraphicFile.Text = resources.GetString("menuOpenGraphicFile.Text");
			this.menuOpenGraphicFile.Visible = ((bool)(resources.GetObject("menuOpenGraphicFile.Visible")));
			this.menuOpenGraphicFile.Click += new System.EventHandler(this.menuOpenGraphicFile_Click);
			// 
			// menuCreateIndexFile
			// 
			this.menuCreateIndexFile.Enabled = ((bool)(resources.GetObject("menuCreateIndexFile.Enabled")));
			this.menuCreateIndexFile.Index = 0;
			this.menuCreateIndexFile.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuCreateIndexFile.Shortcut")));
			this.menuCreateIndexFile.ShowShortcut = ((bool)(resources.GetObject("menuCreateIndexFile.ShowShortcut")));
			this.menuCreateIndexFile.Text = resources.GetString("menuCreateIndexFile.Text");
			this.menuCreateIndexFile.Visible = ((bool)(resources.GetObject("menuCreateIndexFile.Visible")));
			this.menuCreateIndexFile.Click += new System.EventHandler(this.menuCreateIndexFile_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Enabled = ((bool)(resources.GetObject("menuItem2.Enabled")));
			this.menuItem2.Index = 2;
			this.menuItem2.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem2.Shortcut")));
			this.menuItem2.ShowShortcut = ((bool)(resources.GetObject("menuItem2.ShowShortcut")));
			this.menuItem2.Text = resources.GetString("menuItem2.Text");
			this.menuItem2.Visible = ((bool)(resources.GetObject("menuItem2.Visible")));
			// 
			// menuExit
			// 
			this.menuExit.Enabled = ((bool)(resources.GetObject("menuExit.Enabled")));
			this.menuExit.Index = 3;
			this.menuExit.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuExit.Shortcut")));
			this.menuExit.ShowShortcut = ((bool)(resources.GetObject("menuExit.ShowShortcut")));
			this.menuExit.Text = resources.GetString("menuExit.Text");
			this.menuExit.Visible = ((bool)(resources.GetObject("menuExit.Visible")));
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// menuCommand
			// 
			this.menuCommand.Enabled = ((bool)(resources.GetObject("menuCommand.Enabled")));
			this.menuCommand.Index = 1;
			this.menuCommand.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						this.menuSearch,
																						this.menuStop});
			this.menuCommand.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuCommand.Shortcut")));
			this.menuCommand.ShowShortcut = ((bool)(resources.GetObject("menuCommand.ShowShortcut")));
			this.menuCommand.Text = resources.GetString("menuCommand.Text");
			this.menuCommand.Visible = ((bool)(resources.GetObject("menuCommand.Visible")));
			// 
			// menuSearch
			// 
			this.menuSearch.Enabled = ((bool)(resources.GetObject("menuSearch.Enabled")));
			this.menuSearch.Index = 0;
			this.menuSearch.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuSearch.Shortcut")));
			this.menuSearch.ShowShortcut = ((bool)(resources.GetObject("menuSearch.ShowShortcut")));
			this.menuSearch.Text = resources.GetString("menuSearch.Text");
			this.menuSearch.Visible = ((bool)(resources.GetObject("menuSearch.Visible")));
			this.menuSearch.Click += new System.EventHandler(this.menuSearch_Click);
			// 
			// menuStop
			// 
			this.menuStop.Enabled = ((bool)(resources.GetObject("menuStop.Enabled")));
			this.menuStop.Index = 1;
			this.menuStop.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuStop.Shortcut")));
			this.menuStop.ShowShortcut = ((bool)(resources.GetObject("menuStop.ShowShortcut")));
			this.menuStop.Text = resources.GetString("menuStop.Text");
			this.menuStop.Visible = ((bool)(resources.GetObject("menuStop.Visible")));
			this.menuStop.Click += new System.EventHandler(this.menuStop_Click);
			// 
			// menuHelp
			// 
			this.menuHelp.Enabled = ((bool)(resources.GetObject("menuHelp.Enabled")));
			this.menuHelp.Index = 2;
			this.menuHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuVersion});
			this.menuHelp.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuHelp.Shortcut")));
			this.menuHelp.ShowShortcut = ((bool)(resources.GetObject("menuHelp.ShowShortcut")));
			this.menuHelp.Text = resources.GetString("menuHelp.Text");
			this.menuHelp.Visible = ((bool)(resources.GetObject("menuHelp.Visible")));
			// 
			// menuVersion
			// 
			this.menuVersion.Enabled = ((bool)(resources.GetObject("menuVersion.Enabled")));
			this.menuVersion.Index = 0;
			this.menuVersion.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuVersion.Shortcut")));
			this.menuVersion.ShowShortcut = ((bool)(resources.GetObject("menuVersion.ShowShortcut")));
			this.menuVersion.Text = resources.GetString("menuVersion.Text");
			this.menuVersion.Visible = ((bool)(resources.GetObject("menuVersion.Visible")));
			this.menuVersion.Click += new System.EventHandler(this.menuVersion_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Enabled = ((bool)(resources.GetObject("menuItem3.Enabled")));
			this.menuItem3.Index = 3;
			this.menuItem3.Shortcut = ((System.Windows.Forms.Shortcut)(resources.GetObject("menuItem3.Shortcut")));
			this.menuItem3.ShowShortcut = ((bool)(resources.GetObject("menuItem3.ShowShortcut")));
			this.menuItem3.Text = resources.GetString("menuItem3.Text");
			this.menuItem3.Visible = ((bool)(resources.GetObject("menuItem3.Visible")));
			// 
			// btnSearch
			// 
			this.btnSearch.AccessibleDescription = resources.GetString("btnSearch.AccessibleDescription");
			this.btnSearch.AccessibleName = resources.GetString("btnSearch.AccessibleName");
			this.btnSearch.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("btnSearch.Anchor")));
			this.btnSearch.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("btnSearch.BackgroundImage")));
			this.btnSearch.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("btnSearch.Dock")));
			this.btnSearch.Enabled = ((bool)(resources.GetObject("btnSearch.Enabled")));
			this.btnSearch.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("btnSearch.FlatStyle")));
			this.btnSearch.Font = ((System.Drawing.Font)(resources.GetObject("btnSearch.Font")));
			this.btnSearch.Image = ((System.Drawing.Image)(resources.GetObject("btnSearch.Image")));
			this.btnSearch.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("btnSearch.ImageAlign")));
			this.btnSearch.ImageIndex = ((int)(resources.GetObject("btnSearch.ImageIndex")));
			this.btnSearch.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("btnSearch.ImeMode")));
			this.btnSearch.Location = ((System.Drawing.Point)(resources.GetObject("btnSearch.Location")));
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("btnSearch.RightToLeft")));
			this.btnSearch.Size = ((System.Drawing.Size)(resources.GetObject("btnSearch.Size")));
			this.btnSearch.TabIndex = ((int)(resources.GetObject("btnSearch.TabIndex")));
			this.btnSearch.Text = resources.GetString("btnSearch.Text");
			this.btnSearch.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("btnSearch.TextAlign")));
			this.btnSearch.Visible = ((bool)(resources.GetObject("btnSearch.Visible")));
			this.btnSearch.Click += new System.EventHandler(this.btnSearch_Click);
			// 
			// lvResult
			// 
			this.lvResult.AccessibleDescription = resources.GetString("lvResult.AccessibleDescription");
			this.lvResult.AccessibleName = resources.GetString("lvResult.AccessibleName");
			this.lvResult.Alignment = ((System.Windows.Forms.ListViewAlignment)(resources.GetObject("lvResult.Alignment")));
			this.lvResult.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("lvResult.Anchor")));
			this.lvResult.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("lvResult.BackgroundImage")));
			this.lvResult.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																					   this.matchRate,
																					   this.path});
			this.lvResult.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("lvResult.Dock")));
			this.lvResult.Enabled = ((bool)(resources.GetObject("lvResult.Enabled")));
			this.lvResult.Font = ((System.Drawing.Font)(resources.GetObject("lvResult.Font")));
			this.lvResult.FullRowSelect = true;
			this.lvResult.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvResult.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("lvResult.ImeMode")));
			this.lvResult.LabelWrap = ((bool)(resources.GetObject("lvResult.LabelWrap")));
			this.lvResult.Location = ((System.Drawing.Point)(resources.GetObject("lvResult.Location")));
			this.lvResult.MultiSelect = false;
			this.lvResult.Name = "lvResult";
			this.lvResult.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("lvResult.RightToLeft")));
			this.lvResult.Size = ((System.Drawing.Size)(resources.GetObject("lvResult.Size")));
			this.lvResult.TabIndex = ((int)(resources.GetObject("lvResult.TabIndex")));
			this.lvResult.Text = resources.GetString("lvResult.Text");
			this.lvResult.View = System.Windows.Forms.View.Details;
			this.lvResult.Visible = ((bool)(resources.GetObject("lvResult.Visible")));
			this.lvResult.DoubleClick += new System.EventHandler(this.lvResult_DoubleClick);
			// 
			// matchRate
			// 
			this.matchRate.Text = resources.GetString("matchRate.Text");
			this.matchRate.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("matchRate.TextAlign")));
			this.matchRate.Width = ((int)(resources.GetObject("matchRate.Width")));
			// 
			// path
			// 
			this.path.Text = resources.GetString("path.Text");
			this.path.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("path.TextAlign")));
			this.path.Width = ((int)(resources.GetObject("path.Width")));
			// 
			// msgCurrentFilePath
			// 
			this.msgCurrentFilePath.AccessibleDescription = resources.GetString("msgCurrentFilePath.AccessibleDescription");
			this.msgCurrentFilePath.AccessibleName = resources.GetString("msgCurrentFilePath.AccessibleName");
			this.msgCurrentFilePath.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("msgCurrentFilePath.Anchor")));
			this.msgCurrentFilePath.AutoSize = ((bool)(resources.GetObject("msgCurrentFilePath.AutoSize")));
			this.msgCurrentFilePath.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("msgCurrentFilePath.BackgroundImage")));
			this.msgCurrentFilePath.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.msgCurrentFilePath.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("msgCurrentFilePath.Dock")));
			this.msgCurrentFilePath.Enabled = ((bool)(resources.GetObject("msgCurrentFilePath.Enabled")));
			this.msgCurrentFilePath.Font = ((System.Drawing.Font)(resources.GetObject("msgCurrentFilePath.Font")));
			this.msgCurrentFilePath.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("msgCurrentFilePath.ImeMode")));
			this.msgCurrentFilePath.Location = ((System.Drawing.Point)(resources.GetObject("msgCurrentFilePath.Location")));
			this.msgCurrentFilePath.MaxLength = ((int)(resources.GetObject("msgCurrentFilePath.MaxLength")));
			this.msgCurrentFilePath.Multiline = ((bool)(resources.GetObject("msgCurrentFilePath.Multiline")));
			this.msgCurrentFilePath.Name = "msgCurrentFilePath";
			this.msgCurrentFilePath.PasswordChar = ((char)(resources.GetObject("msgCurrentFilePath.PasswordChar")));
			this.msgCurrentFilePath.ReadOnly = true;
			this.msgCurrentFilePath.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("msgCurrentFilePath.RightToLeft")));
			this.msgCurrentFilePath.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("msgCurrentFilePath.ScrollBars")));
			this.msgCurrentFilePath.Size = ((System.Drawing.Size)(resources.GetObject("msgCurrentFilePath.Size")));
			this.msgCurrentFilePath.TabIndex = ((int)(resources.GetObject("msgCurrentFilePath.TabIndex")));
			this.msgCurrentFilePath.TabStop = false;
			this.msgCurrentFilePath.Text = resources.GetString("msgCurrentFilePath.Text");
			this.msgCurrentFilePath.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("msgCurrentFilePath.TextAlign")));
			this.msgCurrentFilePath.Visible = ((bool)(resources.GetObject("msgCurrentFilePath.Visible")));
			this.msgCurrentFilePath.WordWrap = ((bool)(resources.GetObject("msgCurrentFilePath.WordWrap")));
			// 
			// GGG4W
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AllowDrop = true;
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.msgCurrentFilePath);
			this.Controls.Add(this.lvResult);
			this.Controls.Add(this.btnSearch);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.Menu = this.mainMenu;
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "GGG4W";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.Text = resources.GetString("$this.Text");
			this.Closing += new System.ComponentModel.CancelEventHandler(this.GGG4W_Closing);
			this.Load += new System.EventHandler(this.GGG4W_Load);
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.GGG4W_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.GGG4W_DragEnter);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() {
			Application.Run(new GGG4W());
		}

		TGraphicSearch m_gs = null;
		ArrayList m_hits = new ArrayList();
		ResourceManager m_rmStrings = null;
		TSetting m_setting = null;
		TSetting m_settingSaved = null;

		/*
		 * R[obN
		 */

		void OnProgress(TFileInfo info) {
			this.msgCurrentFilePath.Text = info.m_filePath;
		}

		void OnHitItem(TFileInfo info) {
			ListViewItem item = new ListViewItem(info.m_matchRate.ToString());
			item.SubItems.Add(info.m_filePath);
			this.lvResult.Items.Add(item);
			m_hits.Add(info);
		}

		void OnSearchEnd() {
			this.msgCurrentFilePath.Text = "";
			this.btnSearch.Text = m_rmStrings.GetString("RS_SEARCH");
		}
		
		/*
		 * hbOhbv
		 */

		private void GGG4W_DragEnter(object sender, System.Windows.Forms.DragEventArgs e) {
			e.Effect = e.Data.GetDataPresent(DataFormats.FileDrop) ? DragDropEffects.All : DragDropEffects.None;
		}

		private void GGG4W_DragDrop(object sender, System.Windows.Forms.DragEventArgs e) {
			string[] s = (string[])e.Data.GetData(DataFormats.FileDrop, false);
			foreach(string path in s) {
				if (Directory.Exists(path)) {
					m_gs.m_topDirPath = path;
				}			
				else if (File.Exists(path)) {
					if (m_gs.CheckIndexFile(path)) {
						m_gs.m_indexFilePath = path;
					}
					else {
						m_gs.m_target.m_filePath = path;
					}
				}
			}
		}

		/*
		 * ANV
		 */

		private void btnSearch_Click(object sender, System.EventArgs e) {
			if (m_gs.IsWorking()) {
				menuStop_Click(sender, e);
			}
			else {
				menuSearch_Click(sender, e);
			}
		}

		private void lvResult_DoubleClick(object sender, System.EventArgs e) {
			menuOpenGraphicFile_Click(sender, e);
		}

		private void menuCreateIndexFile_Click(object sender, System.EventArgs e) {
			if (m_gs.IsWorking())
				return;
			TCreateIndexFileDlg dlg = new TCreateIndexFileDlg();
			dlg.Setup(ref m_gs);
			if(dlg.ShowDialog() == DialogResult.OK) {
				this.btnSearch.Text = m_rmStrings.GetString("RS_STOP");
				m_gs.m_pixelNumber = m_setting.pixelNumber;
				m_gs.MakeIndexFile();
			}
			dlg.Dispose();
		}

		private void menuSearch_Click(object sender, System.EventArgs e) {
			if (m_gs.IsWorking())
				return;
			TSearchDlg dlg = new TSearchDlg();
			dlg.Setup(ref m_gs);
			if(dlg.ShowDialog() == DialogResult.OK) {
				m_hits.Clear();
				this.lvResult.Items.Clear();
				this.btnSearch.Text = m_rmStrings.GetString("RS_STOP");
				m_gs.m_pixelNumber = m_setting.pixelNumber;
				m_gs.BeginSearch();
			}				
		}
		
		private void menuStop_Click(object sender, System.EventArgs e) {
			m_gs.Stop();
		}

		private void menuOpenGraphicFile_Click(object sender, System.EventArgs e) {
			if (this.lvResult.SelectedItems.Count <= 0)
				return;
			IEnumerator en = this.lvResult.SelectedItems.GetEnumerator();
			en.MoveNext();
			ListViewItem item = (ListViewItem)en.Current;
			int n = this.lvResult.Items.IndexOf(item);
			if (n < 0)
				return;
			TFileInfo info = (TFileInfo)m_hits[n];
			Process.Start(info.m_filePath);
		}

		private void GGG4W_Load(object sender, System.EventArgs e) {
			if (m_setting.location.IsEmpty == false) {
				this.Location = m_setting.location;
				this.Height = m_setting.windowHeight;
				this.Width = m_setting.windowWidth;
			}
		}

		private void GGG4W_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			m_gs.SaveSetting(ref m_setting);
			m_setting.location = this.Location;
			m_setting.windowHeight = this.Height;
			m_setting.windowWidth = this.Width;
			if (m_settingSaved == null || m_settingSaved.Equals(m_setting) == false)
				m_setting.Ending();
			m_gs.Join();
		}

		private void menuExit_Click(object sender, System.EventArgs e) {
			Close();
		}

		private void menuVersion_Click(object sender, System.EventArgs e) {
			MessageBox.Show("GraphicGripGrop 1.0.1", "Version");
		}

	}
}
