//
//  TFileInfo.cs
//  Copyright 2005 Takeshi Yoneki / OSTRA / OSTRACISM CO., All rights reserved.
//
using System;
using System.Drawing;

namespace GGG4W
{
	/// <summary>
	/// TFileInfo 摜t@CNX
	/// </summary>
	public class TFileInfo
	{
		public string m_filePath = null;
		public short[] m_thumbnail = null;
		public int m_thumbnailCount = 0;
		public int m_matchRate = 0;	// v

		public TFileInfo()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		public TFileInfo(string filePath) {
			m_filePath = filePath;
		}

		/// <summary>
		/// e狖e𓾂
		/// </summary>
		/// <param name="thumbnailSize"></param>
		/// <param name="pardon"></param>
		/// <returns></returns>
		static int CalcPardon(int thumbnailSize, int pardon) {
			return thumbnailSize * pardon / 100;
		}

		/// <summary>
		/// Tl[쐬
		/// </summary>
		/// <param name="pixcelNumber"></param>
		/// <returns></returns>
		public bool MakeThumbnail(int pixcelNumber) {
			if (m_filePath == null || m_filePath.Length == 0)
				return false;
			Bitmap simg = null;
			try {
				simg = new Bitmap(m_filePath);
			}
			catch {
			}
			if (simg == null)
				return false;
			int height = pixcelNumber;
			int width = pixcelNumber;
			m_thumbnailCount = height * width;
			m_thumbnail = new short[m_thumbnailCount];
			Bitmap rimg = new Bitmap(simg, new Size(width, height));
			int x, y;
			for (y = 0; y < height; y++) {
				for (x = 0; x < width; x++) {
					Color c = rimg.GetPixel(x, y);
					int r = (c.R >> 4);
					int g = (c.G >> 4);
					int b = (c.B >> 4);
					m_thumbnail[y * width + x] = (short)((r << 8) + (g << 4) + (b));
				}
			}
			simg.Dispose();
			rimg.Dispose();
			return true;
		}
		
		/// <summary>
		/// Tl[r
		/// </summary>
		/// <param name="bits"></param>
		/// <param name="pardon"></param>
		/// <param name="info"></param>
		/// <returns></returns>
		public bool IsEqualThumbnail(int bits, int pardon, ref TFileInfo info) {
			if (m_thumbnailCount != info.m_thumbnailCount)
				return false;
			int pardonNumber = CalcPardon(m_thumbnailCount, 100 - pardon);
			int bad = 0;
			int i;
			for (i = 0; i < m_thumbnailCount; i++) {
				if (bad >= pardonNumber)
					return false;
				int r = ((m_thumbnail[i] >> 8) & 0xF);
				int g = ((m_thumbnail[i] >> 4) & 0xF);
				int b = ((m_thumbnail[i]) & 0xF);
				int ir = ((info.m_thumbnail[i] >> 8) & 0xF);
				int ig = ((info.m_thumbnail[i] >> 4) & 0xF);
				int ib = ((info.m_thumbnail[i]) & 0xF);
				int shift = 4 - bits;
				r >>= shift;
				g >>= shift;
				b >>= shift;
				ir >>= shift;
				ig >>= shift;
				ib >>= shift;
				if ((r == ir || r + 1 == ir || r - 1 == ir) &&
					(g == ig || g + 1 == ig || g - 1 == ig) &&
					(b == ib || b + 1 == ib || b - 1 == ib)) {
				}
				else {				
					bad++;
				}
			}

			info.m_matchRate = (m_thumbnailCount - bad) * 100 / m_thumbnailCount;
			return true;
		}

		/// <summary>
		/// 摜t@C`FbN
		/// </summary>
		/// <param name="filePath"></param>
		/// <returns></returns>
		public static bool checkGraphicFile(string filePath) {
			TFileInfo info = new TFileInfo(filePath);
			bool result = info.MakeThumbnail(8);
			return result;
		}
	}
}
